# Define the kmod package name here.
%define kmod_name sis1100

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 2.6.32-696.el6.%{_target_cpu}}

Name:    %{kmod_name}-kmod
Version: 2.13.9
Release: 1%{?dist}
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     http://www.struck.de/linux1100.htm

BuildRequires: redhat-rpm-config
ExclusiveArch: i686 x86_64

# Sources.
Source0:  %{kmod_name}-%{version}.tar.gz
Source5:  GPL-v2.0.txt
Source10: kmodtool-%{kmod_name}-el6.sh

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the %{kmod_name} kernel module(s).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%package -n %{kmod_name}-utils
Summary: Userspace utilities for %{kmod_name}
Group: System Environment/Kernel
Requires: %{kmod_name}-kmod

%description -n %{kmod_name}-utils
Userspace utilities for %{kmod_name}

%prep
%setup -q -n %{kmod_name}-%{version}
echo "override %{kmod_name} * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf

%build
pushd dev/pci >/dev/null
KSRC=%{_usrsrc}/kernels/%{kversion}
%{__make} %{?_smp_mflags} -C "${KSRC}" M=$PWD modules
popd >/dev/null
%{__make} %{?_smp_mflags} -C sis3100_calls
%{__make} %{?_smp_mflags} -C sis5100_calls
%{__make} %{?_smp_mflags} -C eeprom_tools

%install
%{__install} -d %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} dev/pci/*.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{SOURCE5} %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/

# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;

# Remove the unrequired files.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

# Install udev rules for kmod device
%{__install} -Dp -m0644 udev-rules/92-struck.rules %{buildroot}/etc/udev/rules.d/92-struck.rules

# Install libraries and headers
%{__install} -Dp -m0755 sis3100_calls/lib_sis3100.a %{buildroot}%{_libdir}/sis1100/lib_sis3100.a
%{__install} -Dp -m0644 sis3100_calls/sis3100_vme_calls.h %{buildroot}%{_includedir}/sis1100/sis3100_vme_calls.h
%{__install} -Dp -m0644 sis3100_calls/header/sis9200.h %{buildroot}%{_includedir}/sis1100/sis9200.h

%{__install} -Dp -m0755 sis5100_calls/lib_sis5100.a %{buildroot}%{_libdir}/sis1100/lib_sis5100.a
%{__install} -Dp -m0644 sis5100_calls/sis5100_camac_calls.h %{buildroot}%{_includedir}/sis1100/sis5100_camac_calls.h

%{__install} -Dp -m0755 eeprom_tools/read_eeprom %{buildroot}%{_libexecdir}/sis1100/read_eeprom
%{__install} -Dp -m0755 eeprom_tools/write_eeprom %{buildroot}%{_libexecdir}/sis1100/write_eeprom
%{__install} -Dp -m0755 eeprom_tools/verify_eeprom %{buildroot}%{_libexecdir}/sis1100/verify_eeprom

for filename in $(cd dev/pci; ls *.h); do
  %{__install} -Dp -m0644 dev/pci/${filename} %{buildroot}%{_includedir}/sis1100/${filename}
done

%clean
%{__rm} -rf %{buildroot}

%files -n %{kmod_name}-utils
%defattr(0644,root,root,-)
%attr(0755,root,root) %{_libdir}/sis1100/lib_sis*
%attr(0755,root,root) %{_libexecdir}/sis1100/*
%attr(0644,root,root) %{_includedir}/sis1100/*
/etc/udev/rules.d/92-struck.rules

%changelog
* Fri Jun 09 2017 Akemi Yagi <toracat@elrepo.org> - 2.13.9-1
- With the amended spec file (thanks to Alan Bartlett), patch is no longer needed.

* Wed Jun 07 2017 Akemi Yagi <toracat@elrepo.org> - 2.13.9 
- Initial build.
